"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _hoc = require("@apollo/client/react/hoc");

var _recompose = require("recompose");

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _withGraphql = _interopRequireDefault(require("./withGraphql"));

var _queryCache = _interopRequireDefault(require("./queryCache"));

var _decorateFields = _interopRequireDefault(require("./decorateFields"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var config = {
  client: null,
  context: {},
  logging: false
};

var BaseModel =
/*#__PURE__*/
function () {
  function BaseModel() {
    _classCallCheck(this, BaseModel);
  }

  _createClass(BaseModel, null, [{
    key: "graphql",
    // This is a higher order component that enhances the passed component with the graphql query
    // and mutations. `mutations` must be an array of strings, and those strings must match the
    // method names of the model sub class. `query` must be a string and match a method name of the
    // model sub class.
    //
    // The returned component will have some new props: If you passed a query name, there will be a
    // `data` prop as per react-apollo's specification. The query will be sent to the API as soon as
    // the component is mounted. Each mutation name that you passed will append a function prop to
    // the component with the same name.
    //
    // A mutation will be sent to the API as soon as its function prop is called from within the
    // component. It allows up to three parameters, but only the first one is required:
    // - variables (object|string): The variables required by the mutation. If the mutation expects
    //   an `Input` argument, don't pass the input object, but only the input object's contents.
    //   Example:
    //     `mutation createKid($kid: CreateKidInput!)`
    //     Do not pass `{ kid: { ... } }`, instead simply pass `{ ... }`. The surrounding `kid` is
    //     added automatically.
    //   If the mutation expects a single parameter, simply pass the flat value.
    // - optimisticResponse (object): Ideally, the application should always update its state before
    //   the request to the API is made by trying to predict the server's response. By default, all
    //   variables from the first parameter are used for the optimistic response. Only if you expect
    //   differences between variables and response should you pass this second parameter containing
    //   those parts of the response that differ.
    // - update (function): By default, the cache is kept up to date automatically after a
    //   mutation. There may be situations, however, where you need to update a cache item that is
    //   not related to the mutation you're making. In that case, use this third parameter. It is a
    //   function that receives a single parameter: the data returned by the mutation. The function
    //   must return an object containing three keys:
    //   - id (string): The ID of the cache item (same as the UUID used on the server).
    //   - typename (string): The typename of the cache item (same as the types in the API's graphql
    //     schema).
    //   - data (object): The data you wish to update the cache item with.
    value: function graphql(Component) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (!this._config.client) {
        throw new Error('Must configure base model with apollo client instance');
      }

      var GraphqlComponent = (0, _withGraphql["default"])(Component, this, options);
      return this._composeQueries(options.withoutQuery)(GraphqlComponent);
    }
  }, {
    key: "configure",
    value: function configure() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      config = _objectSpread({}, config, {}, options);
    }
  }, {
    key: "_setPaginationCursor",
    value: function _setPaginationCursor(pagination, variables, items) {
      _queryCache["default"].setPaginationCursor(this.query.query, variables, items.length > 0 ? this.query.paginationCursorMap[pagination.orderBy](items[items.length - 1]) : 'done');
    }
  }, {
    key: "_paginationProps",
    value: function _paginationProps(props, itemName) {
      var _this = this;

      if (!this.query.pagination) {
        return {};
      }

      var pagination = this.query.pagination(props);
      var variables = {};

      if (this.query.variables) {
        variables = this.query.variables(props);
      }

      variables = _objectSpread({}, variables, {
        pagination: pagination
      });
      var items = props.data[itemName];

      var cursor = _queryCache["default"].getPaginationCursor(this.query.query, variables);

      if (items && _queryCache["default"].isActive(this.query.query, variables)) {
        this._setPaginationCursor(pagination, variables, items);
      }

      return {
        loadMore: function loadMore() {
          cursor = _queryCache["default"].getPaginationCursor(_this.query.query, variables);

          if (!cursor) {
            return Promise.resolve({
              done: false
            });
          }

          if (cursor === 'done') {
            return Promise.resolve({
              done: true
            });
          }

          return props.data.fetchMore({
            variables: _objectSpread({}, variables, {
              pagination: _objectSpread({}, variables.pagination, {
                cursor: cursor
              })
            }),
            updateQuery: function updateQuery(cacheData, _ref) {
              var fetchMoreResult = _ref.fetchMoreResult;
              items = fetchMoreResult[itemName];

              _this._setPaginationCursor(pagination, variables, items);

              return _objectSpread({}, cacheData, _defineProperty({}, itemName, [].concat(_toConsumableArray(cacheData[itemName]), _toConsumableArray(fetchMoreResult[itemName].filter(function (_ref2) {
                var id = _ref2.id;
                return !cacheData[itemName].some(function (item) {
                  return item.id === id;
                });
              })))));
            }
          }).then(function () {
            return {
              done: _queryCache["default"].getPaginationCursor(_this.query.query, variables) === 'done'
            };
          });
        }
      };
    }
  }, {
    key: "_composeQueries",
    value: function _composeQueries(withoutQuery) {
      var _this2 = this;

      var composeables = [];

      if (this.query) {
        if (this.query.clientQuery) {
          composeables.push((0, _hoc.graphql)((0, _graphqlTag["default"])(this.query.clientQuery), {
            name: 'clientData'
          }));
        }

        if (!withoutQuery) {
          var queryAst = (0, _graphqlTag["default"])(this.query.query);
          var itemName = queryAst.definitions[0].selectionSet.selections[0].name.value;
          composeables.push((0, _hoc.graphql)(queryAst, {
            alias: itemName,
            options: function options(props) {
              var variables = {};
              var pagination = _this2.query.pagination ? _this2.query.pagination(props) : null;

              if (_this2.query.variables) {
                variables = _this2.query.variables(props);
              }

              if (pagination) {
                variables = _objectSpread({}, variables, {
                  pagination: pagination
                });
              }

              var isDirty = _queryCache["default"].isDirty(_this2.query.query, variables);

              var fetchPolicy = _this2.query.fetchPolicy || 'cache-first';

              if (isDirty) {
                fetchPolicy = 'network-only';

                _queryCache["default"].setClean(_this2.query.query, variables);
              }

              var queryContext = {};

              if (_this2.query.context) {
                queryContext = typeof _this2.query.context === 'function' ? _this2.query.context(props) : _this2.query.context;
              }

              return {
                variables: variables,
                context: _objectSpread({}, _this2._config.context, {}, queryContext),
                fetchPolicy: fetchPolicy,
                // hopefully fixes https://github.com/apollographql/react-apollo/pull/2003
                partialRefetch: true
              };
            },
            props: function props(_props) {
              if (_props.data.error) {
                console.error(_props.data.error);
              }

              return _objectSpread({}, _props, {}, _this2._paginationProps(_props, itemName), {
                data: (0, _decorateFields["default"])(_props.data, _this2.query.decorators)
              });
            },
            skip: this.query.skip || false
          }));
        }
      }

      if (this.mutations) {
        this.mutations.forEach(function (_ref3) {
          var mutation = _ref3.mutation,
              context = _ref3.context;
          var mutationAst = (0, _graphqlTag["default"])(mutation);
          var operationName = mutationAst.definitions[0].name.value;
          composeables.push((0, _hoc.graphql)(mutationAst, {
            name: operationName,
            options: {
              context: _objectSpread({}, _this2._config.context, {}, context || {}, {
                operationName: operationName
              })
            }
          }));
        });
      }

      if (composeables.length === 0) {
        return function (Component) {
          return Component;
        };
      }

      return _recompose.compose.apply(void 0, composeables);
    }
  }, {
    key: "_config",
    get: function get() {
      return config;
    }
  }]);

  return BaseModel;
}();

exports["default"] = BaseModel;