"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _immutabilityHelper = _interopRequireWildcard(require("immutability-helper"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _intervalPromise = _interopRequireDefault(require("interval-promise"));

var _queryCache = _interopRequireDefault(require("./queryCache"));

var _decorateFields = _interopRequireDefault(require("./decorateFields"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

(0, _immutabilityHelper.extend)('$removeById', function (param, original) {
  return original.filter(function (_ref) {
    var id = _ref.id;
    return id !== param;
  });
});
var mutationPollerRaceConditionCheck = false;
var pendingRequests = [];
var requestIdCounter = 0;

var getVariables = function getVariables(data) {
  if (!data.variables) {
    return null;
  }

  var variables = _objectSpread({}, data.variables);

  if (variables.pagination) {
    delete variables.pagination.cursor;
  }

  return variables;
};

var _default = function _default(Component, model, options) {
  var _temp;

  return _temp =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(_temp, _React$Component);

    function _temp() {
      var _getPrototypeOf2;

      var _this;

      _classCallCheck(this, _temp);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(_temp)).call.apply(_getPrototypeOf2, [this].concat(args)));

      _defineProperty(_assertThisInitialized(_this), "unsubscribers", {});

      _defineProperty(_assertThisInitialized(_this), "shouldPoll", false);

      return _this;
    }

    _createClass(_temp, [{
      key: "componentWillMount",
      value: function componentWillMount() {
        this.subscribeToMore(this.props.data);
        this.toggleQueryActive(true, this.props.data);
        this.startPolling();
      }
    }, {
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps(nextProps) {
        this.subscribeToMore(nextProps.data);

        if (this.props.data) {
          if (!nextProps.data) {
            this.toggleQueryActive(false, this.props.data);
          } else if (this.props.data.loading && !nextProps.data.loading) {
            this.toggleQueryActive(true, nextProps.data);
          } else if (!!getVariables(this.props.data) && !!getVariables(nextProps.data) && JSON.stringify(getVariables(nextProps.data)) !== JSON.stringify(getVariables(this.props.data))) {
            this.toggleQueryActive(false, this.props.data);
            this.toggleQueryActive(true, nextProps.data);
          }
        } else {
          this.toggleQueryActive(true, nextProps.data);
        }
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.unsubscribe();
        this.toggleQueryActive(false, this.props.data);
        this.stopPolling();
      }
    }, {
      key: "toggleQueryActive",
      value: function toggleQueryActive(isActive, data) {
        if (!data || data.loading || !model.query || options.withoutQuery) {
          return;
        }

        var method = isActive ? 'setActive' : 'setInactive';

        _queryCache["default"][method](model.query.query, getVariables(data), {
          context: _objectSpread({}, model._config.context, {}, model.query.context || {}),
          dirtyWhen: model.query.dirtyWhen,
          events: model.query.events
        });
      }
    }, {
      key: "subscribeToMore",
      value: function subscribeToMore(data) {
        var _this2 = this;

        if (!model.query || !model.query.subscriptions || options.withoutQuery || data.loading) {
          return;
        }

        var unsubscribe = Object.keys(this.unsubscribers);
        var unsubscribers = model.query.subscriptions.reduce(function (result, current) {
          if (_this2.unsubscribers[current.subscription]) {
            unsubscribe = unsubscribe.filter(function (item) {
              return item !== current.subscription;
            });
            return _objectSpread({}, result, _defineProperty({}, current.subscription, _this2.unsubscribers[current.subscription]));
          }

          var subscriptionAst = (0, _graphqlTag["default"])(current.subscription);
          return _objectSpread({}, result, _defineProperty({}, current.subscription, data.subscribeToMore({
            document: subscriptionAst,
            updateQuery: function updateQuery(cacheData, _ref2) {
              var subscriptionData = _ref2.subscriptionData;
              var subscriptionName = subscriptionAst.definitions[0].name.value;
              var item = subscriptionData.data[subscriptionName];

              if (!item) {
                return cacheData;
              }

              _queryCache["default"].handleEvents(subscriptionName, item, null, model._config.client);

              if (current.cacheUpdatePath) {
                return (0, _immutabilityHelper["default"])(cacheData, current.cacheUpdatePath({
                  item: item,
                  cacheData: cacheData,
                  queryVariables: item.variables
                }));
              }

              return cacheData;
            },
            onError: function onError(error) {
              if (process.env.NODE_ENV === 'development') {
                // eslint-disable-next-line no-console
                console.error(error);
              }
            }
          })));
        }, {});
        unsubscribe.forEach(function (item) {
          _this2.unsubscribers[item]();

          delete _this2.unsubscribers[item];
        });
        this.unsubscribers = unsubscribers;
      }
    }, {
      key: "unsubscribe",
      value: function unsubscribe() {
        Object.values(this.unsubscribers).forEach(function (unsubscribe) {
          return unsubscribe();
        });
        this.unsubscribers = {};
      }
    }, {
      key: "startPolling",
      value: function startPolling() {
        var _this3 = this;

        if (!this.props.data || !model.query || options.withoutQuery || !model.query.polling) {
          return;
        }

        this.shouldPoll = true;

        if (!_queryCache["default"].isActive(model.query.polling.query, getVariables(this.props.data))) {
          var poller =
          /*#__PURE__*/
          function () {
            var _ref3 = _asyncToGenerator(
            /*#__PURE__*/
            regeneratorRuntime.mark(function _callee() {
              var variables, requestId, pollingPromise;
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      _context.prev = 0;
                      variables = model.query.polling.variables ? model.query.polling.variables(_this3.props) : getVariables(_this3.props.data); // If mutations or polling requests are in flight, wait until they are done
                      // before polling again

                      _context.next = 4;
                      return Promise.all(pendingRequests.map(function (_ref4) {
                        var promise = _ref4.promise;
                        return promise;
                      }));

                    case 4:
                      mutationPollerRaceConditionCheck = false;
                      requestIdCounter += 1;
                      requestId = requestIdCounter;
                      pollingPromise = _this3.props.data.fetchMore({
                        query: (0, _graphqlTag["default"])(model.query.polling.query),
                        variables: variables,
                        context: _objectSpread({}, model._config.context, {}, model.query.context || {}),
                        updateQuery: function updateQuery(_, _ref5) {
                          var fetchMoreResult = _ref5.fetchMoreResult;
                          pendingRequests = pendingRequests.filter(function (_ref6) {
                            var id = _ref6.id;
                            return id !== requestId;
                          }); // Don't use the previous result returned by updateQuery but get it
                          // from the cache manually because the previous result may be stale:
                          // https://github.com/apollographql/apollo-client/issues/6471

                          var cacheData = model._config.client.readQuery({
                            query: (0, _graphqlTag["default"])(model.query.query),
                            variables: getVariables(_this3.props.data)
                          }); // Discard the polling result if a mutation happened while the
                          // polling request was in flight - it will be stale


                          if (mutationPollerRaceConditionCheck) {
                            return cacheData;
                          }

                          return (0, _immutabilityHelper["default"])(cacheData, model.query.polling.cacheUpdatePath({
                            item: fetchMoreResult,
                            cacheData: cacheData,
                            queryVariables: getVariables(_this3.props.data)
                          }));
                        }
                      });
                      pendingRequests.push({
                        id: requestId,
                        promise: pollingPromise
                      });
                      _context.next = 11;
                      return pollingPromise;

                    case 11:
                      _context.next = 17;
                      break;

                    case 13:
                      _context.prev = 13;
                      _context.t0 = _context["catch"](0);
                      // Proposed workaround for https://github.com/apollographql/apollo-client/issues/4114
                      console.info('Cancelled poll interval for unmounted component');
                      _this3.shouldPoll = false;

                    case 17:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee, null, [[0, 13]]);
            }));

            return function poller() {
              return _ref3.apply(this, arguments);
            };
          }();

          if (!this.props.data.loading && !_queryCache["default"].isDirty(model.query.query, getVariables(this.props.data))) {
            poller();
          }

          (0, _intervalPromise["default"])(
          /*#__PURE__*/
          function () {
            var _ref7 = _asyncToGenerator(
            /*#__PURE__*/
            regeneratorRuntime.mark(function _callee2(iteration, stop) {
              return regeneratorRuntime.wrap(function _callee2$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      if (_this3.shouldPoll) {
                        _context2.next = 3;
                        break;
                      }

                      stop();
                      return _context2.abrupt("return");

                    case 3:
                      _context2.next = 5;
                      return poller();

                    case 5:
                    case "end":
                      return _context2.stop();
                  }
                }
              }, _callee2);
            }));

            return function (_x, _x2) {
              return _ref7.apply(this, arguments);
            };
          }(), 30000);
        }

        _queryCache["default"].setActive(model.query.polling.query, getVariables(this.props.data));
      }
    }, {
      key: "stopPolling",
      value: function stopPolling() {
        if (!this.props.data || !model.query || options.withoutQuery || !model.query.polling || !_queryCache["default"].isActive(model.query.polling.query, getVariables(this.props.data))) {
          return;
        }

        _queryCache["default"].setInactive(model.query.polling.query, getVariables(this.props.data));

        this.shouldPoll = false;
      }
    }, {
      key: "enhanceMutations",
      value: function enhanceMutations() {
        var _this4 = this;

        if (!model.mutations) {
          return {};
        }

        return model.mutations.reduce(function (result, item) {
          var mutation = item.mutation,
              optimisticResponse = item.optimisticResponse,
              cacheUpdatePath = item.cacheUpdatePath,
              cacheUpdateQuery = item.cacheUpdateQuery,
              _item$makesDirty = item.makesDirty,
              makesDirty = _item$makesDirty === void 0 ? [] : _item$makesDirty,
              context = item.context;
          var mutationAst = (0, _graphqlTag["default"])(mutation);
          var operationName = mutationAst.definitions[0].name.value;
          return _objectSpread({}, result, _defineProperty({}, operationName, function () {
            var variables = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
            var contextOverride = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
            var mutationName = mutationAst.definitions[0].selectionSet.selections[0].name.value;
            var args = mutationAst.definitions[0].selectionSet.selections[0].arguments;
            var mutationVariables = typeof variables === 'string' ? _defineProperty({}, args[0].name.value, variables) : variables;
            var mutationContext = {};

            if (context) {
              mutationContext = typeof context === 'function' ? context(_this4.props) : context;
            }

            requestIdCounter += 1;
            var requestId = requestIdCounter;
            mutationPollerRaceConditionCheck = true; // Wrap apollo's mutate function with options that are identical or at least
            // similar across all mutations to avoid boilerplate in the view components.

            var mutationPromise = _this4.props[operationName]({
              // Automate the argument name, so the variables can be passed as a flat
              // object.
              variables: args.length === 1 ? _defineProperty({}, args[0].name.value, variables) : variables,
              // Assume that all variables will be part of the response. Allow
              // deviations from this assumption to be passed in.
              optimisticResponse: optimisticResponse === null ? null : _defineProperty({}, mutationName, _objectSpread({}, mutationVariables, {}, optimisticResponse ? optimisticResponse({
                mutationVariables: mutationVariables,
                props: _this4.props
              }) : {})),
              // Make sure the cache is up to date after deleting or adding an item.
              update: _this4.updateCacheHandler(mutationName, variables, cacheUpdatePath, cacheUpdateQuery),
              context: _objectSpread({}, model._config.context, {}, mutationContext, {}, contextOverride)
            }).then(function (mutationResult) {
              pendingRequests = pendingRequests.filter(function (_ref11) {
                var id = _ref11.id;
                return id !== requestId;
              });

              _queryCache["default"].setDirty(makesDirty, model._config.client);

              _queryCache["default"].handleEvents(operationName, mutationResult.data[mutationName], variables, model._config.client);

              return mutationResult;
            });

            pendingRequests.push({
              id: requestId,
              promise: mutationPromise
            });
            return mutationPromise;
          }));
        }, {});
      }
    }, {
      key: "updateCacheHandler",
      value: function updateCacheHandler(mutationName, mutationVariables, cacheUpdatePath, cacheUpdateQuery) {
        var _this5 = this;

        return function (cache, _ref12) {
          var data = _ref12.data;

          if (!cacheUpdatePath) {
            return;
          }

          try {
            var fetchQuery = cacheUpdateQuery ? cacheUpdateQuery.query.query : model.query.query;
            var query = (0, _graphqlTag["default"])(fetchQuery);

            _queryCache["default"].getAllVariables(fetchQuery).forEach(function (variables) {
              var cacheData = cache.readQuery({
                query: query,
                variables: variables
              });
              cache.writeQuery({
                query: query,
                data: (0, _immutabilityHelper["default"])(cacheData, cacheUpdatePath({
                  item: data[mutationName],
                  cacheData: (0, _decorateFields["default"])(cacheData, model.query.decorators),
                  queryVariables: variables,
                  mutationVariables: mutationVariables,
                  props: _this5.props
                })),
                variables: variables
              });

              if (model._config.logging) {
                console.log(JSON.stringify({
                  mutationName: mutationName,
                  mutationVariables: mutationVariables,
                  cacheUpdatePath: cacheUpdatePath({
                    item: data[mutationName],
                    cacheData: (0, _decorateFields["default"])(cacheData, model.query.decorators),
                    queryVariables: variables,
                    mutationVariables: mutationVariables,
                    props: _this5.props
                  }),
                  query: fetchQuery,
                  queryVariables: variables
                }, null, 4));
              }
            });
          } catch (error) {
            console.error(error);
            throw error;
          }
        };
      }
    }, {
      key: "render",
      value: function render() {
        return _react["default"].createElement(Component, _objectSpread({}, this.props, {}, this.enhanceMutations()));
      }
    }]);

    return _temp;
  }(_react["default"].Component), _temp;
};

exports["default"] = _default;